	.module SmartLCD_LCD.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
	.area lit(rom, con, rel)
_line1chars::
	.byte 'S,'m
	.byte 'a,'r
	.byte 't,'L
	.byte 'C,'D
	.byte 32,32
	.byte 32,32
	.byte 0
	.dbsym e line1chars _line1chars A[13:13]kc
_line2chars::
	.byte 'V,'e
	.byte 'r,'s
	.byte 'i,'o
	.byte 'n,32
	.byte 49,46
	.byte 48,49
	.byte 0
	.dbsym e line2chars _line2chars A[13:13]kc
_line3chars::
	.byte 'S,'O
	.byte 'C,32
	.byte 'R,'o
	.byte 'b,'o
	.byte 't,'i
	.byte 'c,'s
	.byte 0
	.dbsym e line3chars _line3chars A[13:13]kc
_line4chars::
	.byte 'w,'a
	.byte 'i,'t
	.byte 'i,'n
	.byte 'g,32
	.byte 32,32
	.byte 32,32
	.byte 0
	.dbsym e line4chars _line4chars A[13:13]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
	.dbfunc e LCDWriteSerialByte _LCDWriteSerialByte fV
;           mask -> R20
;              i -> R22
;         inchar -> R16
	.even
_LCDWriteSerialByte::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 82
; /**************************************************************
; 
;    Program Title: SmartLCD Controller 
;    
;    Program Name: SmartLCD_LCD.c		  Version: 0.01
;    
;    Author:  SS/WR	  		  Date:  Febuary 27, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.1
;    
;    Copyright 2004-2008, SOC Machines, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2008 by SOC Machines, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; 
; 
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <math.h>
; //#include <stdio.h>
; #include "TinyLCD_Uart.h"
; #include "TinyLCD_Defines.h"
; #include "TinyLCD_Extern.h"
; //#include "USI_TWI_Slave.h"
; 
; #include "SmartLCD_LCD.h"
; #include "SmartLCD_Accelerometer.h"
; 
; 
; const unsigned char line1chars[] = {'S','m','a','r','t','L','C','D',' ',' ',' ',' ',0x00};
; const unsigned char line2chars[] = {'V','e','r','s','i','o','n',' ','1','.','0','1',0x00};
; const unsigned char line3chars[] = {'S','O','C',' ','R','o','b','o','t','i','c','s',0x00};
; const unsigned char line4chars[] = {'w','a','i','t','i','n','g',' ',' ',' ',' ',' ',0x00};
; unsigned char line1[13],line2[13],line3[13],line4[13];
; unsigned char cursorposition,cursormax,rowptr,colptr,lineptr,escmode;
; unsigned char lcdphoneantennasymbols,lcdstate,symbolmode,voltagevolume;
; unsigned char lcdchiptype;
; //frameerror,dataoverrun,numstrg[9],
; 
; unsigned int count;
; //seconds,minutes,hours,days,
; 
; char  flip2;
; //rxcnt,checkflag,rxcntmax,
; 
; void   LCDWriteSerialByte(unsigned char inchar)
; {
	.dbline 85
;  	unsigned char i,mask;
; 
; 	mask = 0x80;
	ldi R20,128
	.dbline 86
; 	for(i=0; i<8; i++) {
	clr R22
	xjmp L5
L2:
	.dbline 86
	.dbline 87
; 	    ClrBit(LCDDATA,LCD_SCLK);
	cbi 0x8,3
	.dbline 88
; 		if((inchar&mask)) SetBit(LCDDATA,LCD_SI);
	mov R2,R16
	and R2,R20
	breq L6
X0:
	.dbline 88
	sbi 0x8,2
	xjmp L7
L6:
	.dbline 89
; 		else ClrBit(LCDDATA,LCD_SI);
	cbi 0x8,2
L7:
	.dbline 90
; 		mask >>= 1;
	lsr R20
	.dbline 91
; 		SetBit(LCDDATA,LCD_SCLK);
	sbi 0x8,3
	.dbline 92
; 	    }
L3:
	.dbline 86
	inc R22
L5:
	.dbline 86
	cpi R22,8
	brlo L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r mask 20 c
	.dbsym r i 22 c
	.dbsym r inchar 16 c
	.dbend
	.dbfunc e LCDprintchar _LCDprintchar fV
;         inchar -> R10
	.even
_LCDprintchar::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 96
; }
; 
; void   LCDprintchar(unsigned char inchar)
; {
	.dbline 97
; 	LCDCONTROL |= BIT(LA0); // raise A0 high
	sbi 0x5,2
	.dbline 98
; 	LCDCONTROL &= ~BIT(CS); // set CS low
	cbi 0x5,1
	.dbline 99
; 	ShortDelay(1);
	ldi R16,1
	ldi R17,0
	xcall _ShortDelay
	.dbline 100
; 	LCDWriteSerialByte(inchar);
	mov R16,R10
	xcall _LCDWriteSerialByte
	.dbline 101
; 	LCDCONTROL |= BIT(CS); // release CS
	sbi 0x5,1
	.dbline 102
; 	ShortDelay(2);	
	ldi R16,2
	ldi R17,0
	xcall _ShortDelay
	.dbline -2
L8:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e LCDwritecommand _LCDwritecommand fV
;         inchar -> R10
	.even
_LCDwritecommand::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 106
; }
; 
; void   LCDwritecommand(unsigned char inchar)
; { 		
	.dbline 107
; 	LCDCONTROL &= ~BIT(LA0); /* set A0 low */
	cbi 0x5,2
	.dbline 108
; 	LCDCONTROL &= ~BIT(CS);  /* set RS low */
	cbi 0x5,1
	.dbline 109
; 	ShortDelay(1);
	ldi R16,1
	ldi R17,0
	xcall _ShortDelay
	.dbline 110
; 	LCDWriteSerialByte(inchar);
	mov R16,R10
	xcall _LCDWriteSerialByte
	.dbline 111
; 	LCDCONTROL |= BIT(CS); // release CS
	sbi 0x5,1
	.dbline 112
; 	ShortDelay(2);
	ldi R16,2
	ldi R17,0
	xcall _ShortDelay
	.dbline -2
L9:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e LCDDisplayChar _LCDDisplayChar fV
;         inchar -> R10
;        address -> R20
	.even
_LCDDisplayChar::
	st -y,R10
	st -y,R20
	mov R10,R18
	mov R20,R16
	.dbline -1
	.dbline 118
; }
; 
; 
; 
; void   LCDDisplayChar(unsigned char address, unsigned char inchar)
; {
	.dbline 119
;  	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R20
	ori R16,128
	xcall _LCDwritecommand
	.dbline 120
; 	LCDprintchar(inchar);
	mov R16,R10
	xcall _LCDprintchar
	.dbline -2
L10:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym r address 20 c
	.dbend
	.dbfunc e LCD_Write _LCD_Write fV
;           data -> R10
;        address -> R20
	.even
_LCD_Write::
	st -y,R10
	st -y,R20
	mov R10,R18
	mov R20,R16
	.dbline -1
	.dbline 124
; }
; 
; void LCD_Write(unsigned char address,unsigned char data)
; {
	.dbline 125
; 	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R20
	ori R16,128
	xcall _LCDwritecommand
	.dbline 126
; 	LCDprintchar(data);
	mov R16,R10
	xcall _LCDprintchar
	.dbline -2
L11:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r data 10 c
	.dbsym r address 20 c
	.dbend
	.dbfunc e LCDdisplays _LCDdisplays fV
;              j -> <dead>
;              i -> R20
;         instrg -> R10,R11
;        address -> R22
	.even
_LCDdisplays::
	xcall push_xgsetF00C
	movw R10,R18
	mov R22,R16
	.dbline -1
	.dbline 130
; }
; 
; void   LCDdisplays(unsigned char address, char *instrg)
; {
	.dbline 133
; 	char i,j;
; 
; 	i = 0;
	clr R20
	.dbline 134
; 	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R22
	ori R16,128
	xcall _LCDwritecommand
	xjmp L14
L13:
	.dbline 135
; 	while(instrg[i]!=0x00) LCDprintchar(instrg[i++]);
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R30,R2
	clr R31
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _LCDprintchar
L14:
	.dbline 135
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L13
X2:
	.dbline -2
L12:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym l j 1 c
	.dbsym r i 20 c
	.dbsym r instrg 10 pc
	.dbsym r address 22 c
	.dbend
	.dbfunc e LCDprints _LCDprints fV
;              j -> R22
;              i -> R20
;         instrg -> R10,R11
	.even
_LCDprints::
	xcall push_xgsetF00C
	movw R10,R16
	.dbline -1
	.dbline 140
; 
; }
; 
; void   LCDprints(char *instrg)
; {
	.dbline 143
; 	char i,j;
; 
; 	i = 0;
	clr R20
	xjmp L18
L17:
	.dbline 144
; 	while(instrg[i]!=0x00) {
	.dbline 145
; 		if(cursorposition>=cursormax) {
	lds R2,_cursormax
	lds R3,_cursorposition
	cp R3,R2
	brlo L20
X3:
	.dbline 145
	.dbline 146
; 		   cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 147
; 		   return ; // or wrap line
	xjmp L16
L20:
	.dbline 149
; 		   }
; 		else  {
	.dbline 150
; 			  if(instrg[i]==LF) LCDwritecommand(LCDCLR);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,10
	brne L22
X4:
	.dbline 150
	ldi R16,1
	xcall _LCDwritecommand
	xjmp L23
L22:
	.dbline 151
; 			  else if(instrg[i]==CR) LCDwritecommand(LCDHOME);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,13
	brne L24
X5:
	.dbline 151
	ldi R16,16
	xcall _LCDwritecommand
	xjmp L25
L24:
	.dbline 152
; 			  else if(instrg[i]==TAB) for(j=0; j<6; j++) LCDprintchar(0x20);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,9
	brne L26
X6:
	.dbline 152
	clr R22
	xjmp L31
L28:
	.dbline 152
	ldi R16,32
	xcall _LCDprintchar
L29:
	.dbline 152
	inc R22
L31:
	.dbline 152
	cpi R22,6
	brlo L28
X7:
	xjmp L27
L26:
	.dbline 153
; 			  else LCDprintchar(instrg[i++]);
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R30,R2
	clr R31
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _LCDprintchar
L27:
L25:
L23:
	.dbline 154
; 			  cursorposition++;
	lds R24,_cursorposition
	subi R24,255    ; addi 1
	sts _cursorposition,R24
	.dbline 155
; 			  }
	.dbline 156
; 		}
L18:
	.dbline 144
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	breq X9
	xjmp L17
X9:
X8:
	.dbline -2
L16:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r j 22 c
	.dbsym r i 20 c
	.dbsym r instrg 10 pc
	.dbend
	.dbfunc e LCD_Symbols _LCD_Symbols fV
;              i -> R20,R21
;          state -> R22
	.even
_LCD_Symbols::
	xcall push_xgsetF000
	mov R22,R16
	.dbline -1
	.dbline 160
; }
; 
; void LCD_Symbols(unsigned char state)
; { 	 
	.dbline 163
; 	 int i;
; 	 
; 	 if(state==ON) {
	cpi R22,1
	brne L33
X10:
	.dbline 163
	.dbline 164
; 	 	 LCDwritecommand(LCDRAMADDRESS|0x70);
	ldi R16,240
	xcall _LCDwritecommand
	.dbline 165
; 	 	 for(i=0; i<12; i++)  LCDprintchar(0x0b);
	clr R20
	clr R21
L35:
	.dbline 165
	ldi R16,11
	xcall _LCDprintchar
L36:
	.dbline 165
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 165
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L35
X11:
	.dbline 166
; 		 }
	xjmp L34
L33:
	.dbline 167
; 	 else if(state==OFF) {
	tst R22
	brne L39
X12:
	.dbline 167
	.dbline 168
; 	 	 LCDwritecommand(LCDRAMADDRESS|0x70);
	ldi R16,240
	xcall _LCDwritecommand
	.dbline 169
; 	 	 for(i=0; i<12; i++)  LCDprintchar(0x00);
	clr R20
	clr R21
L41:
	.dbline 169
	clr R16
	xcall _LCDprintchar
L42:
	.dbline 169
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 169
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L41
X13:
	.dbline 170
; 		 }
L39:
L34:
	.dbline -2
L32:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r i 20 I
	.dbsym r state 22 c
	.dbend
	.dbfunc e SetBuffers _SetBuffers fV
;              i -> R20
;         inchar -> R16
	.even
_SetBuffers::
	st -y,R20
	.dbline -1
	.dbline 174
; }
; 
; void SetBuffers(unsigned char inchar)
; {
	.dbline 177
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<12; i++) {
	clr R20
	xjmp L49
L46:
	.dbline 177
	.dbline 178
; 	     line1[i] = inchar;
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 179
; 		 line2[i] = inchar;
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 180
; 		 line3[i] = inchar;
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 181
; 		 line4[i] = inchar;
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 182
; 		 }
L47:
	.dbline 177
	inc R20
L49:
	.dbline 177
	cpi R20,12
	brlo L46
X14:
	.dbline -2
L45:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r inchar 16 c
	.dbend
	.dbfunc e Clear_LCD _Clear_LCD fV
;              i -> R20,R21
	.even
_Clear_LCD::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 186
; }
; 
; void Clear_LCD()
; {
	.dbline 190
;  	 int i;
; 	 
; 	 // Clear 4x12 display
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x30+i,' ');
	clr R20
	clr R21
L51:
	.dbline 190
	ldi R18,32
	mov R16,R20
	subi R16,208  ; offset = 48
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L52:
	.dbline 190
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 190
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L51
X15:
	.dbline 191
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x40+i,' ');
	clr R20
	clr R21
L55:
	.dbline 191
	ldi R18,32
	mov R16,R20
	subi R16,192  ; offset = 64
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L56:
	.dbline 191
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 191
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L55
X16:
	.dbline 192
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x50+i,' ');
	clr R20
	clr R21
L59:
	.dbline 192
	ldi R18,32
	mov R16,R20
	subi R16,176  ; offset = 80
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L60:
	.dbline 192
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 192
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L59
X17:
	.dbline 193
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x60+i,' ');
	clr R20
	clr R21
L63:
	.dbline 193
	ldi R18,32
	mov R16,R20
	subi R16,160  ; offset = 96
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L64:
	.dbline 193
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 193
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L63
X18:
	.dbline 196
; 	 
; 	 // Clear buffers
; 	 SetBuffers(' ');
	ldi R16,32
	xcall _SetBuffers
	.dbline 199
; 	 
; 	 // Clear all symbols
; 	 LCD_Symbols(OFF);
	clr R16
	xcall _LCD_Symbols
	.dbline -2
L50:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r i 20 I
	.dbend
	.dbfunc e Init_LCD _Init_LCD fV
	.even
_Init_LCD::
	.dbline -1
	.dbline 210
; }
; 
; 
; /******************************************
;   LCD interface control logic:
;        CS -  0 select device
;        R/W - 0 WR, 1 RD,
;        LA0 - 0 command, 1 data
;  ******************************************/
; void Init_LCD()
; {
	.dbline 211
;      lcdchiptype = LCDCHIPE1007;  // if lcd display is E1007
	ldi R24,7
	sts _lcdchiptype,R24
	.dbline 213
; 	 
; 	 SetBit(PORTB,PINB6);  // set clock high
	sbi 0x5,6
	.dbline 215
; 	 // Reset LCD - hold in reset for 10usec
; 	 LCDCONTROL &= ~BIT(LCDRESET);  // Set Reset line low
	cbi 0x5,0
	.dbline 216
; 	 ShortDelay(200);
	ldi R16,200
	ldi R17,0
	xcall _ShortDelay
	.dbline 217
; 	 LCDCONTROL |= BIT(LCDRESET);  // Set Reset line high
	sbi 0x5,0
	.dbline 218
; 	 ShortDelay(50);
	ldi R16,50
	ldi R17,0
	xcall _ShortDelay
	.dbline 229
; 	
; 	// Static Icon off - display on - RF circuit on - clear RAM
; 	// Set display volume
; 
; // System set command
; //   D3-N2, D2-N1, D0-CG
; //   N2/1 -> 0,0  2 lines
; //   N2/1 -> 0,1  3 lines
; //   N2/1 -> 1,0  4 lines
; //   CG   -> 1 CGRAM used, 0 not used
;      LCDwritecommand(LCDSYSTEMSET|LCD4LINE|LCDCGON);
	ldi R16,105
	xcall _LCDwritecommand
	.dbline 236
; 
; // Static Display Command
; //   D1/0 - 0,0  Display OFF
; //   D1/0 - 0,1  1-2Hz blink
; //   D1/0 - 1,0  3-4Hz blink
; //   D1/0 - 1,1  Display ON
; 	 LCDwritecommand(LCDSTATICDISPLAY|LCDDISPLAYON);
	ldi R16,35
	xcall _LCDwritecommand
	.dbline 245
; 	 
; // Display control command
; //   D3-C, D2-B, D1-DC, D0-D
; //   C  -> 1 cursor on, 0 off
; //   DC -> 1 double cursor on, 0 off
; //   B  -> 1 blink on, 0 off
; //   D  -> 1 display on, 0 off	 
; //	 LCDwritecommand(LCDDISPLAY|LCDCURSORON|LCDCURSORBLINK|LCDCURSORDISPLAYON);
; 	 LCDwritecommand(LCDDISPLAY|LCDCURSORDISPLAYON);
	ldi R16,49
	xcall _LCDwritecommand
	.dbline 251
; 
; // Power Save Command
; //   D1-PS, D0-O
; //   PS -> 1 power save on, 0 off
; //   O  -> 1 oscillator circuit on, 0 off
;      LCDwritecommand(LCDPOWERSAVE|LCDPOWERSAVEOFF|LCDOSCON);
	ldi R16,66
	xcall _LCDwritecommand
	.dbline 254
; 
; 	 // Set data pointer to DDRAM
; 	 LCDwritecommand(LCDRAMADDRESS|0x30);
	ldi R16,176
	xcall _LCDwritecommand
	.dbline 257
; 
; 	 // Wait 20ms for power supply to stabilize
; 	 ShortDelay(30000);	 
	ldi R16,30000
	ldi R17,117
	xcall _ShortDelay
	.dbline 264
; 
; 	 // Power supply control
; 	 //   D2-VC, D1-VF, D0-P
; 	 //   VC -> 1 voltage regulator on, 0 off
; 	 //   VF -> 1 voltage follower on, 0 off
; 	 //   P  -> 1 voltage booster on, 0 off
; 	 LCDwritecommand(LCDPOWERSUPPLY|LCDVOLTREGON|LCDVOLTFOLLOWON|LCDVOLTBOOSTON);
	ldi R16,87
	xcall _LCDwritecommand
	.dbline 270
; //	 LCDwritecommand(LCDPOWERSUPPLY|LCDVOLTREGON|LCDVOLTFOLLOWON);
; 
; 	 // Electronic volume setting
; 	 //   D3-0 - set display brightness
; 	 // TBD - real VDD and adjust Voltage Volume accordingly
; 	 voltagevolume = 0x09;
	ldi R24,9
	sts _voltagevolume,R24
	.dbline 271
;      LCDwritecommand(LCDVOLREG|voltagevolume); 
	mov R16,R24
	ori R16,112
	xcall _LCDwritecommand
	.dbline 274
; 
; 	 // move cursor to home position command
; 	 LCDwritecommand(LCDHOME); 
	ldi R16,16
	xcall _LCDwritecommand
	.dbline 276
;  
;  	 lcdphoneantennasymbols = 0;
	clr R2
	sts _lcdphoneantennasymbols,R2
	.dbline 277
; 	 cursormax = 12;
	ldi R24,12
	sts _cursormax,R24
	.dbline 278
; 	 cursorposition = 0;
	sts _cursorposition,R2
	.dbline 279
; 	 rowptr = 1;
	ldi R24,1
	sts _rowptr,R24
	.dbline 280
; 	 colptr = 0;
	sts _colptr,R2
	.dbline 281
; 	 lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 282
; 	 lcdstate = NO_ACTIVE_STATE;
	sts _lcdstate,R2
	.dbline 283
; 	 symbolmode = NO_ACTIVE_STATE;
	sts _symbolmode,R2
	.dbline -2
L67:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayLCDBuffers _DisplayLCDBuffers fV
	.even
_DisplayLCDBuffers::
	.dbline -1
	.dbline 287
; }
; 
; void DisplayLCDBuffers()
; {
	.dbline 288
; 	 LCDdisplays(LINE1,line1);
	ldi R18,<_line1
	ldi R19,>_line1
	ldi R16,48
	xcall _LCDdisplays
	.dbline 289
;    	 LCDdisplays(LINE2,line2);
	ldi R18,<_line2
	ldi R19,>_line2
	ldi R16,64
	xcall _LCDdisplays
	.dbline 290
;    	 LCDdisplays(LINE3,line3);
	ldi R18,<_line3
	ldi R19,>_line3
	ldi R16,80
	xcall _LCDdisplays
	.dbline 291
;    	 LCDdisplays(LINE4,line4);	 
	ldi R18,<_line4
	ldi R19,>_line4
	ldi R16,96
	xcall _LCDdisplays
	.dbline -2
L68:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LoadSignon _LoadSignon fV
;              i -> <dead>
	.even
_LoadSignon::
	.dbline -1
	.dbline 295
; }
; 
; void LoadSignon()
; {
	.dbline 298
;  	 unsigned char i;
; 	 
; 	 cstrcpy(line1,line1chars);
	ldi R18,<_line1chars
	ldi R19,>_line1chars
	ldi R16,<_line1
	ldi R17,>_line1
	xcall _cstrcpy
	.dbline 299
; 	 cstrcpy(line2,line2chars);
	ldi R18,<_line2chars
	ldi R19,>_line2chars
	ldi R16,<_line2
	ldi R17,>_line2
	xcall _cstrcpy
	.dbline 300
; 	 cstrcpy(line3,line3chars);
	ldi R18,<_line3chars
	ldi R19,>_line3chars
	ldi R16,<_line3
	ldi R17,>_line3
	xcall _cstrcpy
	.dbline 301
; 	 cstrcpy(line4,line4chars);
	ldi R18,<_line4chars
	ldi R19,>_line4chars
	ldi R16,<_line4
	ldi R17,>_line4
	xcall _cstrcpy
	.dbline -2
L69:
	.dbline 0 ; func end
	ret
	.dbsym l i 1 c
	.dbend
	.dbfunc e ShiftUpLine _ShiftUpLine fV
;              i -> R20
	.even
_ShiftUpLine::
	st -y,R20
	.dbline -1
	.dbline 305
; }
; 
; void ShiftUpLine()
; {
	.dbline 308
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<12; i++) {
	clr R20
	xjmp L74
L71:
	.dbline 308
	.dbline 309
; 	     line1[i] = line2[i];
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 310
; 		 line2[i] = line3[i];
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 311
; 		 line3[i] = line4[i];
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 312
; 		 line4[i] = ' ';
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,32
	std z+0,R24
	.dbline 313
; 		 }
L72:
	.dbline 308
	inc R20
L74:
	.dbline 308
	cpi R20,12
	brsh X20
	xjmp L71
X20:
X19:
	.dbline 314
;      DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 315
; 	 cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline -2
L70:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e PutCharinBuffer _PutCharinBuffer fV
;         inchar -> R10
;        address -> R18
;            row -> R16
	.even
_PutCharinBuffer::
	st -y,R10
	ldd R10,y+1
	.dbline -1
	.dbline 319
; }
; 
; void PutCharinBuffer(unsigned char row,unsigned char address,unsigned char inchar)
; {
	.dbline 320
;     if(row==0)  line1[address] = inchar;
	tst R16
	brne L76
X21:
	.dbline 320
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L77
L76:
	.dbline 321
; 	else if(row==1)  line2[address] = inchar;
	cpi R16,1
	brne L78
X22:
	.dbline 321
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L79
L78:
	.dbline 322
; 	else if(row==2)  line3[address] = inchar;
	cpi R16,2
	brne L80
X23:
	.dbline 322
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L81
L80:
	.dbline 323
; 	else if(row==3)  line4[address] = inchar;
	cpi R16,3
	brne L82
X24:
	.dbline 323
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
L82:
L81:
L79:
L77:
	.dbline -2
L75:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym r address 18 c
	.dbsym r row 16 c
	.dbend
	.dbfunc e LCD_Dsymbol _LCD_Dsymbol fV
;          state -> R20
	.even
_LCD_Dsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 327
; }
; 
; void LCD_Dsymbol(unsigned char state)
; {
	.dbline 328
;     if(state==ON) LCD_Write(0x70,0x08);
	cpi R20,1
	brne L85
X25:
	.dbline 328
	ldi R18,8
	ldi R16,112
	xcall _LCD_Write
	xjmp L86
L85:
	.dbline 329
; 	else if(state==OFF) LCD_Write(0x70,0);
	tst R20
	brne L87
X26:
	.dbline 329
	clr R18
	ldi R16,112
	xcall _LCD_Write
L87:
L86:
	.dbline -2
L84:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Rsymbol _LCD_Rsymbol fV
;          state -> R20
	.even
_LCD_Rsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 333
; }
; 
; void LCD_Rsymbol(unsigned char state)
; {
	.dbline 334
;     if(state==ON) LCD_Write(0x75,0x02);
	cpi R20,1
	brne L90
X27:
	.dbline 334
	ldi R18,2
	ldi R16,117
	xcall _LCD_Write
	xjmp L91
L90:
	.dbline 335
; 	else if(state==OFF) LCD_Write(0x75,0);
	tst R20
	brne L92
X28:
	.dbline 335
	clr R18
	ldi R16,117
	xcall _LCD_Write
L92:
L91:
	.dbline -2
L89:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Vsymbol _LCD_Vsymbol fV
;          state -> R20
	.even
_LCD_Vsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 339
; }
; 
; void LCD_Vsymbol(unsigned char state)
; {
	.dbline 340
;     if(state==ON) LCD_Write(0x78,0x08);
	cpi R20,1
	brne L95
X29:
	.dbline 340
	ldi R18,8
	ldi R16,120
	xcall _LCD_Write
	xjmp L96
L95:
	.dbline 341
; 	else if(state==OFF) LCD_Write(0x78,0);
	tst R20
	brne L97
X30:
	.dbline 341
	clr R18
	ldi R16,120
	xcall _LCD_Write
L97:
L96:
	.dbline -2
L94:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Phone _LCD_Phone fV
;          state -> R20
	.even
_LCD_Phone::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 345
; }
; 
; void LCD_Phone(unsigned char state)
; {
	.dbline 346
;     if(state==LCD_PHONE_ON) {
	cpi R20,1
	brne L100
X31:
	.dbline 346
	.dbline 347
; 	    lcdphoneantennasymbols |= LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,2
	sts _lcdphoneantennasymbols,R24
	.dbline 348
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 349
; 		LCD_Write(0x74,0);
	clr R18
	ldi R16,116
	xcall _LCD_Write
	.dbline 350
; 	    }
	xjmp L101
L100:
	.dbline 351
; 	else if(state==LCD_SLASHPHONE) {
	cpi R20,2
	brne L102
X32:
	.dbline 351
	.dbline 352
; 	    lcdphoneantennasymbols |= LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,2
	sts _lcdphoneantennasymbols,R24
	.dbline 353
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 354
; 		LCD_Write(0x74,0x08);
	ldi R18,8
	ldi R16,116
	xcall _LCD_Write
	.dbline 355
; 	    }
	xjmp L103
L102:
	.dbline 356
; 	else if(state==LCD_PHONE_OFF) {
	cpi R20,3
	brne L104
X33:
	.dbline 356
	.dbline 357
; 	    lcdphoneantennasymbols &= ~LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,253
	sts _lcdphoneantennasymbols,R24
	.dbline 358
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 359
; 		LCD_Write(0x74,0);
	clr R18
	ldi R16,116
	xcall _LCD_Write
	.dbline 360
; 	    }
L104:
L103:
L101:
	.dbline -2
L99:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Envelope _LCD_Envelope fV
;          state -> R20
	.even
_LCD_Envelope::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 364
; }
; 
; void LCD_Envelope(unsigned char state)
; {
	.dbline 365
;     if(state==ON) LCD_Write(0x76,0x02);
	cpi R20,1
	brne L107
X34:
	.dbline 365
	ldi R18,2
	ldi R16,118
	xcall _LCD_Write
	xjmp L108
L107:
	.dbline 366
; 	else if(state==OFF) LCD_Write(0x76,0);
	tst R20
	brne L109
X35:
	.dbline 366
	clr R18
	ldi R16,118
	xcall _LCD_Write
L109:
L108:
	.dbline -2
L106:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Battery _LCD_Battery fV
;          level -> R20
	.even
_LCD_Battery::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 371
; }
; 
; 
; void LCD_Battery(unsigned char level)
; {
	.dbline 372
;  	 if(level==LCD_BATTERY_EMPTY)  {
	cpi R20,2
	brne L112
X36:
	.dbline 372
	.dbline 373
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 374
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 375
; 	     LCD_Write(0x7b,0);
	clr R18
	ldi R16,123
	xcall _LCD_Write
	.dbline 376
; 		 }
L112:
	.dbline 377
;  	 if(level==LCD_BATTERY_QUARTER)  {
	cpi R20,3
	brne L114
X37:
	.dbline 377
	.dbline 378
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 379
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 380
; 	     LCD_Write(0x7b,0x08);
	ldi R18,8
	ldi R16,123
	xcall _LCD_Write
	.dbline 381
; 		 }
L114:
	.dbline 382
;  	 if(level==LCD_BATTERY_HALF)  {
	cpi R20,4
	brne L116
X38:
	.dbline 382
	.dbline 383
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 384
; 	     LCD_Write(0x7a,0x02);
	ldi R18,2
	ldi R16,122
	xcall _LCD_Write
	.dbline 385
; 	     LCD_Write(0x7b,0x08);
	ldi R18,8
	ldi R16,123
	xcall _LCD_Write
	.dbline 386
; 		 }
L116:
	.dbline 387
;  	 if(level==LCD_BATTERY_THREEQUARTER)  {
	cpi R20,5
	brne L118
X39:
	.dbline 387
	.dbline 388
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 389
; 	     LCD_Write(0x7a,0x02);
	ldi R18,2
	ldi R16,122
	xcall _LCD_Write
	.dbline 390
; 	     LCD_Write(0x7b,0x0b);
	ldi R18,11
	ldi R16,123
	xcall _LCD_Write
	.dbline 391
; 		 }
L118:
	.dbline 392
;  	 if(level==LCD_BATTERY_FULL)  {
	cpi R20,6
	brne L120
X40:
	.dbline 392
	.dbline 393
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 394
; 	     LCD_Write(0x7a,0x0b);
	ldi R18,11
	ldi R16,122
	xcall _LCD_Write
	.dbline 395
; 	     LCD_Write(0x7b,0x0b);
	ldi R18,11
	ldi R16,123
	xcall _LCD_Write
	.dbline 396
; 		 }
L120:
	.dbline 397
;  	 if(level==LCD_BATTERY_OFF)  {
	cpi R20,1
	brne L122
X41:
	.dbline 397
	.dbline 398
; 	     LCD_Write(0x79,0);
	clr R18
	ldi R16,121
	xcall _LCD_Write
	.dbline 399
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 400
; 	     LCD_Write(0x7b,0);
	clr R18
	ldi R16,123
	xcall _LCD_Write
	.dbline 401
; 		 }
L122:
	.dbline -2
L111:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r level 20 c
	.dbend
	.dbfunc e LCD_Antenna _LCD_Antenna fV
;          level -> R20
	.even
_LCD_Antenna::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 405
; }
; 
; void LCD_Antenna(unsigned char level)
; {
	.dbline 406
;  	 if(level==LCD_ANTENNA_EMPTY)  {
	cpi R20,2
	brne L125
X42:
	.dbline 406
	.dbline 407
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 408
; 	     LCD_Write(0x71,0x08);
	ldi R18,8
	ldi R16,113
	xcall _LCD_Write
	.dbline 409
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 410
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 411
; 		 }
L125:
	.dbline 412
;   	 if(level==LCD_ANTENNA_QUARTER)  {
	cpi R20,3
	brne L127
X43:
	.dbline 412
	.dbline 413
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 414
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 415
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 416
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 417
; 		 }
L127:
	.dbline 418
;  	 if(level==LCD_ANTENNA_HALF)  {
	cpi R20,4
	brne L129
X44:
	.dbline 418
	.dbline 419
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 420
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 421
; 	     LCD_Write(0x72,0x08);
	ldi R18,8
	ldi R16,114
	xcall _LCD_Write
	.dbline 422
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 423
; 		 }
L129:
	.dbline 424
;  	 if(level==LCD_ANTENNA_THREEQUARTER)  {
	cpi R20,5
	brne L131
X45:
	.dbline 424
	.dbline 425
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 426
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 427
; 	     LCD_Write(0x72,0x0b);
	ldi R18,11
	ldi R16,114
	xcall _LCD_Write
	.dbline 428
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 429
; 		 }
L131:
	.dbline 430
;  	 if(level==LCD_ANTENNA_FULL)  {
	cpi R20,6
	brne L133
X46:
	.dbline 430
	.dbline 431
; 	     lcdphoneantennasymbols |= LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,8
	sts _lcdphoneantennasymbols,R24
	.dbline 432
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 433
; 	     LCD_Write(0x72,0x0b);
	ldi R18,11
	ldi R16,114
	xcall _LCD_Write
	.dbline 434
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 435
; 		 }
L133:
	.dbline 436
;  	 if(level==LCD_ANTENNA_OFF)  {
	cpi R20,1
	brne L135
X47:
	.dbline 436
	.dbline 437
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 438
; 	     LCD_Write(0x71,0);
	clr R18
	ldi R16,113
	xcall _LCD_Write
	.dbline 439
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 440
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 441
; 		 }
L135:
	.dbline -2
L124:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r level 20 c
	.dbend
	.dbfunc e GetRowfromLine _GetRowfromLine fc
;           line -> R16
	.even
_GetRowfromLine::
	.dbline -1
	.dbline 445
; }
; 
; unsigned char GetRowfromLine(unsigned char line)
; {
	.dbline 446
;  	 if(line==LINE1) return 0;
	cpi R16,48
	brne L138
X48:
	.dbline 446
	clr R16
	xjmp L137
L138:
	.dbline 447
; 	 if(line==LINE2) return 1;
	cpi R16,64
	brne L140
X49:
	.dbline 447
	ldi R16,1
	xjmp L137
L140:
	.dbline 448
; 	 if(line==LINE3) return 2;
	cpi R16,80
	brne L142
X50:
	.dbline 448
	ldi R16,2
	xjmp L137
L142:
	.dbline 449
; 	 if(line==LINE4) return 3;
	cpi R16,96
	brne L144
X51:
	.dbline 449
	ldi R16,3
	xjmp L137
L144:
	.dbline 450
; 	 return 0;
	clr R16
	.dbline -2
L137:
	.dbline 0 ; func end
	ret
	.dbsym r line 16 c
	.dbend
	.dbfunc e SendCharToDisplay _SendCharToDisplay fV
;         inchar -> R10
	.even
_SendCharToDisplay::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 454
; }
; 
; void SendCharToDisplay(unsigned char inchar)
; {
	.dbline 455
; 	if(cursorposition>11) {
	ldi R24,11
	lds R2,_cursorposition
	cp R24,R2
	brsh L147
X52:
	.dbline 455
	.dbline 456
; 		if(lineptr==LINE4) ShiftUpLine();
	lds R24,_lineptr
	cpi R24,96
	brne L149
X53:
	.dbline 456
	xcall _ShiftUpLine
	xjmp L150
L149:
	.dbline 457
; 		else {
	.dbline 458
; 			lineptr += 0x10;
	lds R24,_lineptr
	subi R24,240    ; addi 16
	sts _lineptr,R24
	.dbline 459
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 460
; 			}
L150:
	.dbline 461
; 		}				
L147:
	.dbline 462
; 	LCDDisplayChar(lineptr+cursorposition,inchar);
	mov R18,R10
	lds R2,_cursorposition
	lds R16,_lineptr
	add R16,R2
	xcall _LCDDisplayChar
	.dbline 463
; 	PutCharinBuffer(GetRowfromLine(lineptr),inchar,cursorposition);
	lds R16,_lineptr
	xcall _GetRowfromLine
	lds R2,_cursorposition
	std y+0,R2
	mov R18,R10
	xcall _PutCharinBuffer
	.dbline 464
; 	cursorposition++;
	lds R24,_cursorposition
	subi R24,255    ; addi 1
	sts _cursorposition,R24
	.dbline -2
L146:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e IncrementLinePtr _IncrementLinePtr fV
	.even
_IncrementLinePtr::
	.dbline -1
	.dbline 468
; }
; 
; void IncrementLinePtr()
; {
	.dbline 469
;     if(lineptr==LINE1)  lineptr = LINE2;
	lds R24,_lineptr
	cpi R24,48
	brne L152
X54:
	.dbline 469
	ldi R24,64
	sts _lineptr,R24
	xjmp L153
L152:
	.dbline 470
; 	else if(lineptr==LINE2) lineptr = LINE3;
	lds R24,_lineptr
	cpi R24,64
	brne L154
X55:
	.dbline 470
	ldi R24,80
	sts _lineptr,R24
	xjmp L155
L154:
	.dbline 471
; 	else if(lineptr==LINE3) lineptr = LINE4;
	lds R24,_lineptr
	cpi R24,80
	brne L156
X56:
	.dbline 471
	ldi R24,96
	sts _lineptr,R24
L156:
L155:
L153:
	.dbline -2
L151:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ParseEscSubCommand _ParseEscSubCommand fV
;         inchar -> R20
	.even
_ParseEscSubCommand::
	xcall push_xgsetF000
	mov R20,R16
	.dbline -1
	.dbline 476
; }
; 
; 
; void ParseEscSubCommand(unsigned char inchar)
; {
	.dbline 477
;  	 switch (symbolmode) {
	lds R22,_symbolmode
	clr R23
	cpi R22,8
	ldi R30,0
	cpc R23,R30
	breq L162
X57:
	cpi R22,10
	ldi R30,0
	cpc R23,R30
	breq L169
X58:
	cpi R22,11
	ldi R30,0
	cpc R23,R30
	breq L176
X59:
	xjmp L159
L162:
	.dbline 479
; 		case TWI_ADDRESS_STATE:
; 		    if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_ON);
	cpi R20,1
	brne L163
X60:
	.dbline 479
	ldi R16,1
	xcall _LCD_Phone
	xjmp L160
L163:
	.dbline 480
; 			else if(inchar==LCD_SLASHPHONE) LCD_Phone(LCD_SLASHPHONE);
	cpi R20,2
	brne L165
X61:
	.dbline 480
	ldi R16,2
	xcall _LCD_Phone
	xjmp L160
L165:
	.dbline 481
; 			else if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_OFF);
	cpi R20,1
	brne L160
X62:
	.dbline 481
	ldi R16,3
	xcall _LCD_Phone
	.dbline 482
; 			break;
	xjmp L160
L169:
	.dbline 484
; 		case LED_BLINK_STATE:
; 		    if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_ON);
	cpi R20,1
	brne L170
X63:
	.dbline 484
	ldi R16,1
	xcall _LCD_Phone
	xjmp L160
L170:
	.dbline 485
; 			else if(inchar==LCD_SLASHPHONE) LCD_Phone(LCD_SLASHPHONE);
	cpi R20,2
	brne L172
X64:
	.dbline 485
	ldi R16,2
	xcall _LCD_Phone
	xjmp L160
L172:
	.dbline 486
; 			else if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_OFF);
	cpi R20,1
	brne L160
X65:
	.dbline 486
	ldi R16,3
	xcall _LCD_Phone
	.dbline 487
; 			break;
	xjmp L160
L176:
	.dbline 489
; 		case VOLTAGE_STATE:
; 		    if(inchar=='o') LCD_Vsymbol(ON);
	cpi R20,111
	brne L177
X66:
	.dbline 489
	ldi R16,1
	xcall _LCD_Vsymbol
	xjmp L160
L177:
	.dbline 490
; 			else if(inchar=='f') LCD_Vsymbol(OFF);
	cpi R20,102
	brne L160
X67:
	.dbline 490
	clr R16
	xcall _LCD_Vsymbol
	.dbline 491
; 			break;
L159:
L160:
	.dbline 493
; 		}
;  	 lcdstate = NO_ACTIVE_STATE;
	clr R2
	sts _lcdstate,R2
	.dbline -2
L158:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e ParseSymbolCommand _ParseSymbolCommand fV
;         inchar -> R20
	.even
_ParseSymbolCommand::
	xcall push_xgsetF000
	mov R20,R16
	.dbline -1
	.dbline 497
; }
; 
; void ParseSymbolCommand(unsigned char inchar)
; {
	.dbline 498
;  	 switch (symbolmode) {
	lds R22,_symbolmode
	clr R23
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	breq L185
X68:
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	breq L186
X69:
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	breq L187
X70:
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	breq L192
X71:
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	breq L197
X72:
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	breq L202
X73:
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	brne X83
	xjmp L207
X83:
X74:
	xjmp L182
L185:
	.dbline 500
; 		case ANTENNA_STATE:
; 		    LCD_Antenna(inchar);
	mov R16,R20
	xcall _LCD_Antenna
	.dbline 501
; 			break;
	xjmp L183
L186:
	.dbline 503
; 		case BATTERY_STATE:
; 		    LCD_Battery(inchar);
	mov R16,R20
	xcall _LCD_Battery
	.dbline 504
; 			break;
	xjmp L183
L187:
	.dbline 506
; 		case VSYM_STATE:
; 		    if(inchar=='o') LCD_Vsymbol(ON);
	cpi R20,111
	brne L188
X75:
	.dbline 506
	ldi R16,1
	xcall _LCD_Vsymbol
	xjmp L183
L188:
	.dbline 507
; 			else if(inchar=='f') LCD_Vsymbol(OFF);
	cpi R20,102
	brne L183
X76:
	.dbline 507
	clr R16
	xcall _LCD_Vsymbol
	.dbline 508
; 			break;
	xjmp L183
L192:
	.dbline 510
; 		case DSYM_STATE:
; 		    if(inchar=='o') LCD_Dsymbol(ON);
	cpi R20,111
	brne L193
X77:
	.dbline 510
	ldi R16,1
	xcall _LCD_Dsymbol
	xjmp L183
L193:
	.dbline 511
; 			else if(inchar=='f') LCD_Dsymbol(OFF);
	cpi R20,102
	brne L183
X78:
	.dbline 511
	clr R16
	xcall _LCD_Dsymbol
	.dbline 512
; 			break;
	xjmp L183
L197:
	.dbline 514
; 		case RSYM_STATE:
; 		    if(inchar=='o') LCD_Rsymbol(ON);
	cpi R20,111
	brne L198
X79:
	.dbline 514
	ldi R16,1
	xcall _LCD_Rsymbol
	xjmp L183
L198:
	.dbline 515
; 			else if(inchar=='f') LCD_Rsymbol(OFF);
	cpi R20,102
	brne L183
X80:
	.dbline 515
	clr R16
	xcall _LCD_Rsymbol
	.dbline 516
; 			break;
	xjmp L183
L202:
	.dbline 518
; 		case ENVELOPE_STATE:
; 		    if(inchar=='o') LCD_Envelope(ON);
	cpi R20,111
	brne L203
X81:
	.dbline 518
	ldi R16,1
	xcall _LCD_Envelope
	xjmp L183
L203:
	.dbline 519
; 			else if(inchar=='f') LCD_Envelope(OFF);
	cpi R20,102
	brne L183
X82:
	.dbline 519
	clr R16
	xcall _LCD_Envelope
	.dbline 520
; 			break;
	xjmp L183
L207:
	.dbline 522
; 		case PHONE_STATE:
; 		    LCD_Phone(inchar);
	mov R16,R20
	xcall _LCD_Phone
	.dbline 523
; 			break;
L182:
L183:
	.dbline 525
; 	     }
;  	 lcdstate = NO_ACTIVE_STATE;
	clr R2
	sts _lcdstate,R2
	.dbline 526
; 	 symbolmode = NO_ACTIVE_STATE;
	sts _symbolmode,R2
	.dbline -2
L181:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e ParseEscCommand _ParseEscCommand fV
;         inchar -> R10
	.even
_ParseEscCommand::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 530
; }
; 
; void ParseEscCommand(unsigned char inchar)
; {
	.dbline 531
;     switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,99
	ldi R30,0
	cpc R21,R30
	brne X97
	xjmp L212
X97:
X84:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	brne X98
	xjmp L218
X98:
X85:
	ldi R24,102
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L224
X86:
L223:
	cpi R20,49
	ldi R30,0
	cpc R21,R30
	brne X99
	xjmp L213
X99:
X87:
	cpi R20,50
	ldi R30,0
	cpc R21,R30
	brne X100
	xjmp L214
X100:
X88:
	cpi R20,51
	ldi R30,0
	cpc R21,R30
	brne X101
	xjmp L215
X101:
X89:
	cpi R20,52
	ldi R30,0
	cpc R21,R30
	brne X102
	xjmp L216
X102:
X90:
	xjmp L209
L224:
	cpi R20,108
	ldi R30,0
	cpc R21,R30
	brne X103
	xjmp L221
X103:
X91:
	cpi R20,111
	ldi R30,0
	cpc R21,R30
	brne X104
	xjmp L217
X104:
X92:
	cpi R20,108
	ldi R30,0
	cpc R21,R30
	brge X105
	xjmp L209
X105:
X93:
L225:
	cpi R20,115
	ldi R30,0
	cpc R21,R30
	brne X106
	xjmp L219
X106:
X94:
	cpi R20,116
	ldi R30,0
	cpc R21,R30
	brne X107
	xjmp L222
X107:
X95:
	cpi R20,118
	ldi R30,0
	cpc R21,R30
	brne X108
	xjmp L220
X108:
X96:
	xjmp L209
L212:
	.dbline 533
; 	    case 'c':
; 		    Clear_LCD();
	xcall _Clear_LCD
	.dbline 534
; 			lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 535
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 536
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 537
; 			break;
	xjmp L210
L213:
	.dbline 539
; 		case '1':
; 		    lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 540
; 		    cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 541
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 542
; 			break;
	xjmp L210
L214:
	.dbline 544
; 		case '2':
; 		    lineptr = LINE2;
	ldi R24,64
	sts _lineptr,R24
	.dbline 545
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 546
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 547
; 			break;
	xjmp L210
L215:
	.dbline 549
; 		case '3':
; 		    lineptr = LINE3;
	ldi R24,80
	sts _lineptr,R24
	.dbline 550
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 551
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 552
; 			break;
	xjmp L210
L216:
	.dbline 554
; 		case '4':
; 		    lineptr = LINE4;
	ldi R24,96
	sts _lineptr,R24
	.dbline 555
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 556
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 557
; 			break;
	xjmp L210
L217:
	.dbline 559
; 		case 'o':
; 		    LCD_LED_Power(ON);
	ldi R16,1
	xcall _LCD_LED_Power
	.dbline 560
; 			escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline 561
; 			break;
	xjmp L210
L218:
	.dbline 563
; 		case 'f':
; 		    LCD_LED_Power(OFF);
	clr R16
	xcall _LCD_LED_Power
	.dbline 564
; 			escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline 565
; 			break;
	xjmp L210
L219:
	.dbline 567
; 		case 's':
; 		    lcdstate = LCD_SYMBOL_STATE;
	ldi R24,9
	sts _lcdstate,R24
	.dbline 568
; 			break;
	xjmp L210
L220:
	.dbline 570
; 		case 'v':
; 		    lcdstate = VOLTAGE_STATE;
	ldi R24,11
	sts _lcdstate,R24
	.dbline 571
; 			break;
	xjmp L210
L221:
	.dbline 573
; 		case 'l':
; 		    lcdstate = LED_BLINK_STATE;
	ldi R24,10
	sts _lcdstate,R24
	.dbline 574
; 			break;
	xjmp L210
L222:
	.dbline 576
; 		case 't':
; 		    lcdstate = TWI_ADDRESS_STATE;
	ldi R24,8
	sts _lcdstate,R24
	.dbline 577
; 			break;
	xjmp L210
L209:
	.dbline 579
; 		default:
; 		    escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline 580
; 			break;
L210:
	.dbline 582
; 		}
; 	escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline -2
L208:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e ParseChar _ParseChar fV
;         inchar -> R10
	.even
_ParseChar::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 586
; }
; 
; void ParseChar(unsigned char inchar)
; {
	.dbline 587
; 	if(escmode==ON) {
	lds R24,_escmode
	cpi R24,1
	brne L227
X109:
	.dbline 587
	.dbline 588
; 		ParseEscCommand(inchar);
	mov R16,R10
	xcall _ParseEscCommand
	.dbline 589
; 		}
	xjmp L228
L227:
	.dbline 590
; 	else {
	.dbline 591
; 	    if(symbolmode) ParseSymbolCommand(inchar);
	lds R2,_symbolmode
	tst R2
	breq L229
X110:
	.dbline 591
	mov R16,R10
	xcall _ParseSymbolCommand
	xjmp L230
L229:
	.dbline 592
; 	    else if(lcdstate==LCD_SYMBOL_STATE) symbolmode = inchar;
	lds R24,_lcdstate
	cpi R24,9
	brne L231
X111:
	.dbline 592
	sts _symbolmode,R10
	xjmp L232
L231:
	.dbline 593
; 		else if(lcdstate) ParseEscSubCommand(inchar);
	lds R2,_lcdstate
	tst R2
	breq L233
X112:
	.dbline 593
	mov R16,R10
	xcall _ParseEscSubCommand
	xjmp L234
L233:
	.dbline 594
; 		else {
	.dbline 595
; 	      switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brne X126
	xjmp L243
X126:
X113:
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	brne X127
	xjmp L244
X127:
X114:
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brne X128
	xjmp L245
X128:
X115:
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brne X129
	xjmp L246
X129:
X116:
	cpi R20,5
	ldi R30,0
	cpc R21,R30
	brne X130
	xjmp L247
X130:
X117:
	cpi R20,6
	ldi R30,0
	cpc R21,R30
	brne X131
	xjmp L248
X131:
X118:
	cpi R20,7
	ldi R30,0
	cpc R21,R30
	brne X132
	xjmp L249
X132:
X119:
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brne X133
	xjmp L250
X133:
X120:
	cpi R20,10
	ldi R30,0
	cpc R21,R30
	breq L240
X121:
	cpi R20,13
	ldi R30,0
	cpc R21,R30
	breq L239
X122:
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brge X134
	xjmp L235
X134:
X123:
L251:
	cpi R20,27
	ldi R30,0
	cpc R21,R30
	breq L238
X124:
	xjmp L235
L238:
	.dbline 597
; 		    case ESC:
; 				escmode = ON;  
	ldi R24,1
	sts _escmode,R24
	.dbline 598
; 				break;
	xjmp L236
L239:
	.dbline 600
; 		    case CR:
; 				cursorposition = 0; 
	clr R2
	sts _cursorposition,R2
	.dbline 601
; 				break;
	xjmp L236
L240:
	.dbline 603
; 		    case LF:
; 				if(lineptr==LINE4) ShiftUpLine();
	lds R24,_lineptr
	cpi R24,96
	brne L241
X125:
	.dbline 603
	xcall _ShiftUpLine
	xjmp L236
L241:
	.dbline 604
;  				else IncrementLinePtr();
	xcall _IncrementLinePtr
	.dbline 605
; 				break;
	xjmp L236
L243:
	.dbline 607
; 		    case 0x01:
; 				LCD_Vsymbol(ON); 
	ldi R16,1
	xcall _LCD_Vsymbol
	.dbline 608
; 				break;
	xjmp L236
L244:
	.dbline 610
; 		    case 0x02:
; 				LCD_Vsymbol(OFF);  
	clr R16
	xcall _LCD_Vsymbol
	.dbline 611
; 				break;
	xjmp L236
L245:
	.dbline 613
; 		    case 0x03:
; 				LCD_Dsymbol(ON); 
	ldi R16,1
	xcall _LCD_Dsymbol
	.dbline 614
; 				break;
	xjmp L236
L246:
	.dbline 616
; 		    case 0x04:
; 				LCD_Dsymbol(OFF);  
	clr R16
	xcall _LCD_Dsymbol
	.dbline 617
; 				break;
	xjmp L236
L247:
	.dbline 619
; 		    case 0x05:
; 				LCD_Rsymbol(ON); 
	ldi R16,1
	xcall _LCD_Rsymbol
	.dbline 620
; 				break;
	xjmp L236
L248:
	.dbline 622
; 		    case 0x06:
; 				LCD_Rsymbol(OFF);  
	clr R16
	xcall _LCD_Rsymbol
	.dbline 623
; 				break;
	xjmp L236
L249:
	.dbline 625
; 		    case 0x07:
; 				LCD_Envelope(ON); 
	ldi R16,1
	xcall _LCD_Envelope
	.dbline 626
; 				break;
	xjmp L236
L250:
	.dbline 628
; 		    case 0x08:
; 				LCD_Envelope(OFF);  
	clr R16
	xcall _LCD_Envelope
	.dbline 629
; 				break;
	xjmp L236
L235:
	.dbline 631
; 			default:
; 			    SendCharToDisplay(inchar);
	mov R16,R10
	xcall _SendCharToDisplay
	.dbline 632
; 				break;
L236:
	.dbline 634
; 			}
; 		  }
L234:
L232:
L230:
	.dbline 635
; 		}
L228:
	.dbline -2
L226:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e ParseStrg _ParseStrg fV
;              i -> R10
;         instrg -> R12,R13
	.even
_ParseStrg::
	xcall push_xgset003C
	movw R12,R16
	.dbline -1
	.dbline 641
; }
; 
; 
; 
; void ParseStrg(unsigned char *instrg)
; {
	.dbline 644
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<strlen(instrg); i++)  ParseChar(instrg[i]);
	clr R10
	xjmp L256
L253:
	.dbline 644
	mov R30,R10
	clr R31
	add R30,R12
	adc R31,R13
	ldd R16,z+0
	xcall _ParseChar
L254:
	.dbline 644
	inc R10
L256:
	.dbline 644
	movw R16,R12
	xcall _strlen
	mov R2,R10
	clr R3
	cp R2,R16
	cpc R3,R17
	brlo L253
X135:
	.dbline -2
L252:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r i 10 c
	.dbsym r instrg 12 pc
	.dbend
	.dbfunc e PutStringinBuffer _PutStringinBuffer fV
;              i -> R20
;           strg -> R14,R15
;         column -> R10
;            row -> R12
	.even
_PutStringinBuffer::
	xcall push_xgset30FC
	mov R10,R18
	mov R12,R16
	sbiw R28,1
	ldd R14,y+9
	ldd R15,y+10
	.dbline -1
	.dbline 648
; }
; 
; void PutStringinBuffer(unsigned char row,unsigned char column,char *strg)
; {	 
	.dbline 651
; 	 unsigned char i;
; 	 
; 	 for(i=0; i<strlen(strg); i++)  PutCharinBuffer(row,column+i,strg[i]);
	clr R20
	xjmp L261
L258:
	.dbline 651
	mov R30,R20
	clr R31
	add R30,R14
	adc R31,R15
	ldd R2,z+0
	std y+0,R2
	mov R18,R10
	add R18,R20
	mov R16,R12
	xcall _PutCharinBuffer
L259:
	.dbline 651
	inc R20
L261:
	.dbline 651
	movw R16,R14
	xcall _strlen
	mov R2,R20
	clr R3
	cp R2,R16
	cpc R3,R17
	brlo L258
X136:
	xjmp L263
L262:
	.dbline 653
; 	 while (i<12)
; 	 {
	.dbline 654
; 	  PutCharinBuffer(row,column+i,' ');
	ldi R24,32
	std y+0,R24
	mov R18,R10
	add R18,R20
	mov R16,R12
	xcall _PutCharinBuffer
	.dbline 655
; 	  i++;
	inc R20
	.dbline 656
; 	 }
L263:
	.dbline 652
	cpi R20,12
	brlo L262
X137:
	.dbline -2
L257:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset30FC
	.dbsym r i 20 c
	.dbsym r strg 14 pc
	.dbsym r column 10 c
	.dbsym r row 12 c
	.dbend
	.dbfunc e GetLine _GetLine fc
;            row -> R16
	.even
_GetLine::
	.dbline -1
	.dbline 660
; }
; 
; unsigned char GetLine(unsigned char row)
; {
	.dbline 661
;     if(row==0) return LINE1;
	tst R16
	brne L266
X138:
	.dbline 661
	ldi R16,48
	xjmp L265
L266:
	.dbline 662
; 	if(row==1) return LINE2;
	cpi R16,1
	brne L268
X139:
	.dbline 662
	ldi R16,64
	xjmp L265
L268:
	.dbline 663
; 	if(row==2) return LINE3;
	cpi R16,2
	brne L270
X140:
	.dbline 663
	ldi R16,80
	xjmp L265
L270:
	.dbline 664
; 	if(row==3) return LINE4;
	cpi R16,3
	brne L272
X141:
	.dbline 664
	ldi R16,96
	xjmp L265
L272:
	.dbline 665
; 	return LINE1;
	ldi R16,48
	.dbline -2
L265:
	.dbline 0 ; func end
	ret
	.dbsym r row 16 c
	.dbend
	.dbfunc e Display_Voltage_Volume _Display_Voltage_Volume fV
;    analogvalue -> <dead>
;           strg -> y+2
;         column -> R20
;            row -> R10
	.even
_Display_Voltage_Volume::
	st -y,R10
	st -y,R20
	mov R20,R18
	mov R10,R16
	sbiw R28,7
	.dbline -1
	.dbline 669
; }
; 
; void Display_Voltage_Volume(unsigned char row,unsigned char column)
; {
	.dbline 673
;  	 char strg[5];
;  	 int analogvalue;
; 	 
; 	 PutStringinBuffer(row,column,"Volt v=");
	ldi R24,<L275
	ldi R25,>L275
	std y+1,R25
	std y+0,R24
	mov R18,R20
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline 674
; 	 bytetohex(voltagevolume);
	lds R16,_voltagevolume
	xcall _bytetohex
	.dbline 675
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 676
; 	 PutStringinBuffer(row,column+7,hexbyte);
	ldi R24,<_hexbyte
	ldi R25,>_hexbyte
	std y+1,R25
	std y+0,R24
	mov R18,R20
	subi R18,249    ; addi 7
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L274:
	.dbline 0 ; func end
	adiw R28,7
	ld R20,y+
	ld R10,y+
	ret
	.dbsym l analogvalue 3 I
	.dbsym l strg 2 A[5:5]c
	.dbsym r column 20 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Display_Voltage_Reference _Display_Voltage_Reference fV
;     newvoltvol -> <dead>
;    analogvalue -> R22,R23
;           strg -> y+2
;         column -> R20
;            row -> R10
	.even
_Display_Voltage_Reference::
	xcall push_xgsetF00C
	mov R20,R18
	mov R10,R16
	sbiw R28,7
	.dbline -1
	.dbline 680
; }
; 
; void Display_Voltage_Reference(unsigned char row,unsigned char column)
; {
	.dbline 684
;  	 char strg[5];
;  	 int analogvalue,newvoltvol;
; 	 
; 	 PutStringinBuffer(row,column,"Analog0=");
	ldi R24,<L277
	ldi R25,>L277
	std y+1,R25
	std y+0,R24
	mov R18,R20
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline 685
;  	 analogvalue = Read_ADC(0, ADCINTERNAL);
	clr R18
	clr R16
	xcall _Read_ADC
	movw R22,R16
	.dbline 687
; 	  
; 	 bytetohex((analogvalue>>8)&0xff);
	mov R16,R17
	clr R17
	sbrc R16,7
	com R17
	andi R17,0
	xcall _bytetohex
	.dbline 688
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 689
; 	 bytetohex((analogvalue&0x00ff));
	mov R16,R22
	andi R17,0
	xcall _bytetohex
	.dbline 690
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 691
; 	 PutStringinBuffer(row,column+8,strg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	mov R18,R20
	subi R18,248    ; addi 8
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L276:
	.dbline 0 ; func end
	adiw R28,7
	xjmp pop_xgsetF00C
	.dbsym l newvoltvol 3 I
	.dbsym r analogvalue 22 I
	.dbsym l strg 2 A[5:5]c
	.dbsym r column 20 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Adjust_VoltageVolume _Adjust_VoltageVolume fV
	.even
_Adjust_VoltageVolume::
	.dbline -1
	.dbline 695
; }
; 
; void  Adjust_VoltageVolume()
; {
	.dbline 696
; 	 if((voltagevolume=(1+(574-Read_ADC(0, ADCINTERNAL))/14))>0x0f) 
	clr R18
	clr R16
	xcall _Read_ADC
	movw R2,R16
	ldi R16,574
	ldi R17,2
	sub R16,R2
	sbc R17,R3
	ldi R18,14
	ldi R19,0
	xcall div16s
	movw R24,R16
	adiw R24,1
	mov R2,R24
	sts _voltagevolume,R2
	ldi R24,15
	cp R24,R2
	brsh L279
X142:
	.dbline 698
; //	 if((voltagevolume=(1+(554-Read_ADC(0, ADCINTERNAL))/14))>0x0f) 
; 	     voltagevolume = 0x0c;
	ldi R24,12
	sts _voltagevolume,R24
L279:
	.dbline 699
; 	 LCDwritecommand(LCDVOLREG|voltagevolume); 
	lds R16,_voltagevolume
	ori R16,112
	xcall _LCDwritecommand
	.dbline -2
L278:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Display_Display_Parameters _Display_Display_Parameters fV
	.even
_Display_Display_Parameters::
	.dbline -1
	.dbline 702
; }
; void Display_Display_Parameters()
; {
	.dbline 703
; 	if(flip2==ON) {
	lds R24,_flip2
	cpi R24,1
	brne L282
X143:
	.dbline 703
	.dbline 705
; 		//LCD_Symbols(ON);
; 		Display_Voltage_Reference(0,0);
	clr R18
	clr R16
	xcall _Display_Voltage_Reference
	.dbline 706
; 		Display_Voltage_Volume(1,0);
	clr R18
	ldi R16,1
	xcall _Display_Voltage_Volume
	.dbline 707
; 		DisplayTime(3,0);
	clr R18
	ldi R16,3
	xcall _DisplayTime
	.dbline 708
; 		LED_Power(OFF);
	clr R16
	xcall _LED_Power
	.dbline 710
; 		//LCD_LED_Power(ON);
; 		flip2 = YES;
	ldi R24,1
	sts _flip2,R24
	.dbline 712
; 		//line4[11] = '.';
;     	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 713
; 		}
	xjmp L283
L282:
	.dbline 714
; 	else {
	.dbline 717
; 		//line4[11] = ' ';
; 		//LCD_Symbols(OFF);	
;     	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 719
; 		//LCD_LED_Power(OFF);
; 		LED_Power(ON);
	ldi R16,1
	xcall _LED_Power
	.dbline 720
; 		flip2 = NO;
	clr R2
	sts _flip2,R2
	.dbline 721
; 		}
L283:
	.dbline 722
; 	mseccountdown2 = 250;
	ldi R24,250
	ldi R25,0
	sts _mseccountdown2+1,R25
	sts _mseccountdown2,R24
	.dbline -2
L281:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayPointPattern _DisplayPointPattern fV
	.even
_DisplayPointPattern::
	.dbline -1
	.dbline 726
; }
; 
; void DisplayPointPattern()
; {
	.dbline 727
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 728
; 	line4[7] = '.';
	ldi R24,46
	sts _line4+7,R24
	.dbline 729
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 730
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 731
; 	line4[8] = '.';
	ldi R24,46
	sts _line4+8,R24
	.dbline 732
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 733
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 734
; 	line4[9] = '.';
	ldi R24,46
	sts _line4+9,R24
	.dbline 735
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 736
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 737
; 	line4[10] = '.';
	ldi R24,46
	sts _line4+10,R24
	.dbline 738
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 739
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 740
; 	line4[11] = '.';
	ldi R24,46
	sts _line4+11,R24
	.dbline 741
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 742
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline -2
L284:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Display_Count _Display_Count fV
;        outstrg -> y+2
	.even
_Display_Count::
	sbiw R28,14
	.dbline -1
	.dbline 746
; }
; 
; void Display_Count()
; {
	.dbline 749
;  	char outstrg[12];
; 	
; 	rtccountdown1 = 256;
	ldi R24,256
	ldi R25,1
	sts _rtccountdown1+1,R25
	sts _rtccountdown1,R24
	.dbline 750
; 	bytetohex((count>>8)&0xff);
	lds R16,_count
	lds R17,_count+1
	mov R16,R17
	clr R17
	andi R17,0
	xcall _bytetohex
	.dbline 751
; 	strcpy(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 752
; 	bytetohex((count&0x00ff));
	lds R16,_count
	andi R17,0
	xcall _bytetohex
	.dbline 753
; 	strcat(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 754
; 	PutStringinBuffer(2,0,"count=");
	ldi R24,<L291
	ldi R25,>L291
	std y+1,R25
	std y+0,R24
	clr R18
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 755
; 	PutStringinBuffer(2,6,outstrg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,6
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 756
; 	count++;
	lds R24,_count
	lds R25,_count+1
	adiw R24,1
	sts _count+1,R25
	sts _count,R24
	.dbline -2
L290:
	.dbline 0 ; func end
	adiw R28,14
	ret
	.dbsym l outstrg 2 A[12:12]c
	.dbend
	.dbfunc e SplashScreen _SplashScreen fV
	.even
_SplashScreen::
	.dbline -1
	.dbline 760
; }
; 
; void SplashScreen()
; {
	.dbline 761
; 	LoadSignon();
	xcall _LoadSignon
	.dbline 762
; 	LCD_Symbols(ON);
	ldi R16,1
	xcall _LCD_Symbols
	.dbline 763
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 764
; 	DisplayPointPattern();
	xcall _DisplayPointPattern
	.dbline 765
; 	Clear_LCD();
	xcall _Clear_LCD
	.dbline 766
; 	Delaymsec(250);
	ldi R16,250
	ldi R17,0
	xcall _Delaymsec
	.dbline -2
L292:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e bytetoint _bytetoint fV
;           ones -> R20
;           tens -> R22
;           byte -> R10
	.even
_bytetoint::
	xcall push_xgsetF00C
	mov R10,R16
	.dbline -1
	.dbline 771
; }
; 
; 
; void bytetoint(unsigned char byte)
; {
	.dbline 774
;  	 unsigned char tens,ones;
; 	 
; 	 tens = byte/10;
	ldi R17,10
	mov R16,R10
	xcall div8u
	mov R22,R16
	.dbline 775
; 	 ones = byte%10;
	ldi R17,10
	mov R16,R10
	xcall mod8u
	mov R20,R16
	.dbline 776
; 	 hexbyte[0] = tens + '0';
	mov R24,R22
	subi R24,208    ; addi 48
	sts _hexbyte,R24
	.dbline 777
; 	 hexbyte[1] = ones + '0';
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte+1,R24
	.dbline 778
; 	 hexbyte[2] = 0x00;
	clr R2
	sts _hexbyte+2,R2
	.dbline -2
L293:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r ones 20 c
	.dbsym r tens 22 c
	.dbsym r byte 10 c
	.dbend
	.dbfunc e DisplayTime _DisplayTime fV
;           strg -> y+2
;         column -> R12
;            row -> R10
	.even
_DisplayTime::
	st -y,R10
	st -y,R12
	mov R12,R18
	mov R10,R16
	sbiw R28,11
	.dbline -1
	.dbline 784
; }
; 
; 
; 
; void DisplayTime(unsigned char row,unsigned char column)
; {
	.dbline 788
;  	 char strg[9];
; 	 	
; 	 //PutStringinBuffer(column,"t=");
; 	 bytetoint(hours);
	lds R16,_hours
	xcall _bytetoint
	.dbline 789
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 790
; 	 strcat(strg,":");
	ldi R18,<L297
	ldi R19,>L297
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 791
; 	 bytetoint(minutes);
	lds R16,_minutes
	xcall _bytetoint
	.dbline 792
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 793
; 	 strcat(strg,":");
	ldi R18,<L297
	ldi R19,>L297
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 794
; 	 bytetoint(seconds);
	lds R16,_seconds
	xcall _bytetoint
	.dbline 795
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 796
; 	 PutStringinBuffer(row,column,strg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	mov R18,R12
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L296:
	.dbline 0 ; func end
	adiw R28,11
	ld R12,y+
	ld R10,y+
	ret
	.dbsym l strg 2 A[9:9]c
	.dbsym r column 12 c
	.dbsym r row 10 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
_flip2::
	.blkb 1
	.dbsym e flip2 _flip2 c
_count::
	.blkb 2
	.dbsym e count _count i
_lcdchiptype::
	.blkb 1
	.dbsym e lcdchiptype _lcdchiptype c
_symbolmode::
	.blkb 1
	.dbsym e symbolmode _symbolmode c
_lcdstate::
	.blkb 1
	.dbsym e lcdstate _lcdstate c
_lcdphoneantennasymbols::
	.blkb 1
	.dbsym e lcdphoneantennasymbols _lcdphoneantennasymbols c
_escmode::
	.blkb 1
	.dbsym e escmode _escmode c
_lineptr::
	.blkb 1
	.dbsym e lineptr _lineptr c
_colptr::
	.blkb 1
	.dbsym e colptr _colptr c
_rowptr::
	.blkb 1
	.dbsym e rowptr _rowptr c
_cursormax::
	.blkb 1
	.dbsym e cursormax _cursormax c
_cursorposition::
	.blkb 1
	.dbsym e cursorposition _cursorposition c
_line4::
	.blkb 13
	.dbsym e line4 _line4 A[13:13]c
_line3::
	.blkb 13
	.dbsym e line3 _line3 A[13:13]c
_line2::
	.blkb 13
	.dbsym e line2 _line2 A[13:13]c
_line1::
	.blkb 13
	.dbsym e line1 _line1 A[13:13]c
_voltagevolume::
	.blkb 1
	.dbsym e voltagevolume _voltagevolume c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
L297:
	.blkb 2
	.area idata
	.byte 58,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
L291:
	.blkb 7
	.area idata
	.byte 'c,'o,'u,'n,'t,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
L277:
	.blkb 9
	.area idata
	.byte 'A,'n,'a,'l,'o,'g,48,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
L275:
	.blkb 8
	.area idata
	.byte 'V,'o,'l,'t,32,'v,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_LCD.c
; }
